<form [formGroup]="taskUpdateForm" class="update-task-modal-dialog">
  <div mat-dialog-content>
    <mat-form-field class="full-width">
      <input matInput formControlName="title" [(ngModel)]="data.task.title" class="task-title" placeholder="Title">
      <mat-error *ngIf="taskUpdateForm.invalid">{{getTitleErrorMessage()}}</mat-error>
    </mat-form-field>
    <mat-form-field class="full-width">
      <textarea matInput formControlName="description" [(ngModel)]="data.task.description" placeholder="Description"></textarea>
    </mat-form-field>
    <mat-form-field class="full-width">
      <input matInput formControlName="dueDate" [matDatepicker]="pickerDueDate" [(ngModel)]="data.task.dueDate" placeholder="Due date">
      <mat-datepicker-toggle matSuffix [for]="pickerDueDate"></mat-datepicker-toggle>
      <mat-datepicker #pickerDueDate></mat-datepicker>
    </mat-form-field>
    <mat-form-field class="full-width">
      <input matInput formControlName="priorityDate" [matDatepicker]="pickerPriorityDate" [(ngModel)]="data.task.priorityDate" placeholder="Priority date">
      <mat-datepicker-toggle matSuffix [for]="pickerPriorityDate"></mat-datepicker-toggle>
      <mat-datepicker #pickerPriorityDate></mat-datepicker>
      <mat-error *ngIf="taskUpdateForm.invalid">{{getPriorityDateErrorMessage()}}</mat-error>
    </mat-form-field>
    <mat-form-field class="full-width">
      <mat-select formControlName="project" [(ngModel)]="data.task.project" placeholder="Project">
        <mat-option *ngFor="let project of projects" [value]="project.value">
          {{project.viewValue}}
        </mat-option>
      </mat-select>
      <mat-error *ngIf="taskUpdateForm.invalid">{{getProjectErrorMessage()}}</mat-error>
    </mat-form-field>
    <div *ngIf="taskUpdateForm.errors?.forbiddenDate && (taskUpdateForm.touched || taskUpdateForm.dirty)" class="form-error">The due date must be before the priority date!</div>
  </div>
  <div mat-dialog-actions>
    <button mat-icon-button (click)="onDelete()"><mat-icon>delete</mat-icon></button>
    <span class="spacer"></span>
    <button mat-button (click)="onCancel()">Cancel</button>
    <button mat-button (click)="onSubmit()" [mat-dialog-close]="data.task" [disabled]="taskUpdateForm.invalid">Save</button>
  </div>
</form>
